package example

import (
	"context"
	"errors"
	"github.com/go-redis/redis/v8"
	"log"
	"redisMq"
	"testing"
	"time"
)

func callBack(ctx context.Context, msg *redisMq.MsgEntity) error {
	log.Println(msg)
	return errors.New("error_test")
}

func TestConsumer(t *testing.T) {
	client := redis.NewClient(&redis.Options{
		Addr:     "192.168.8.1:6379",
		Password: "",
	})

	topic := "test_stream_topic"
	groupId := "my_test_group"
	consumerId := "consumer_1"

	consumer, err := redisMq.NewConsumer(client, topic, groupId, consumerId, callBack,
		redisMq.WithReceiveTimeout(time.Second),
		redisMq.WithMaxRetryLimit(2),
		redisMq.WithHandleMsgTimeout(time.Second),
		redisMq.WithDeadLetterDeliverTimeout(time.Second),
		redisMq.WithDeadLetterMailbox(&redisMq.DeadLetterMailboxImpl{}))

	if err != nil {
		log.Fatal(err)
	}

	defer consumer.Stop()

	time.Sleep(time.Second * 10)
}
